package auth

import (
	"net/http"

	"git.noahlan.cn/noahlan/ntool-biz/zero/statusz"
	"github.com/zeromicro/go-zero/rest/httpx"

	"git.noahlan.cn/n-admin/n-admin-server/api/internal/logic/auth"
	"git.noahlan.cn/n-admin/n-admin-server/api/internal/svc"
	"git.noahlan.cn/n-admin/n-admin-server/api/internal/types"
)

// swagger:route get /api/auth/oauth/login auth OauthLogin
//
// Oauth log in | Oauth 第三方登录，获取登录地址（通常针对PC网页登录，APP端自行获取code）
//
// Oauth log in | Oauth 第三方登录，获取登录地址（通常针对PC网页登录，APP端自行获取code）
//
// Responses:
//  200: OauthLoginResp

func OauthLoginHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		const transErr = true
		var req types.OauthLoginReq
		if err := httpx.Parse(r, &req); err != nil {
			statusz.ResponseHandler(r, w, transErr, nil, err)
			return
		}

		l := auth.NewOauthLoginLogic(r, r.Context(), svcCtx)
		resp, err := l.OauthLogin(&req)

		statusz.ResponseHandler(r, w, transErr, resp, err)

	}
}
